diff -uwr sourceold/scripts/dp88_ar.cpp source/scripts/dp88_ar.cpp
--- sourceold/scripts/dp88_ar.cpp	2012-02-23 12:06:21.704101500 +0800
+++ source/scripts/dp88_ar.cpp	2012-05-23 10:32:15.882812500 +0800
@@ -21,6 +21,8 @@
 #include "VehicleGameObjDef.h"
 #include "MoveablePhysClass.h"
 #include "SList.h"
+#include "OffenseObjectClass.h"
+#include "WeaponBagClass.h"
 
 /*------------------------
 Game Controller
@@ -186,60 +188,6 @@
 		mirageTank_disguisePresets[2] = new char[strlen(mtDisguise)+1];
 		strcpy ( mirageTank_disguisePresets[2], mtDisguise );
 	}
-
-
-
-
-	// Disable VTOL units in non-flying maps
-	if ( !Is_Map_Flying() )
-	{
-		PurchaseSettingsDefClass* p = NULL;
-		DefinitionClass* d = NULL;
-
-		// Soviet - Vehicles
-		p = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(0));
-		for ( int i = 0; p != NULL && i < 10; i++ )
-		{
-			d = Find_Definition(p->Get_Definition(i));
-			if ( d != NULL && d->Get_Class_ID() == (uint32)12304 && ((VehicleGameObjDef*)d)->Get_Type() == VEHICLE_TYPE_FLYING )
-			{
-				p->Set_Hidden(i,true);
-			}
-		}
-
-		// Allies - Vehicles
-		p = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(1));
-		for ( int i = 0; p != NULL && i < 10; i++ )
-		{
-			d = Find_Definition(p->Get_Definition(i));
-			if ( d != NULL && d->Get_Class_ID() == (uint32)12304 && ((VehicleGameObjDef*)d)->Get_Type() == VEHICLE_TYPE_FLYING )
-			{
-				p->Set_Hidden(i,true);
-			}
-		}
-
-		// Soviet - Secret Vehicles
-		p = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(0));
-		for ( int i = 0; p != NULL && i < 10; i++ )
-		{
-			d = Find_Definition(p->Get_Definition(i));
-			if ( d != NULL && d->Get_Class_ID() == (uint32)12304 && ((VehicleGameObjDef*)d)->Get_Type() == VEHICLE_TYPE_FLYING )
-			{
-				p->Set_Hidden(i,true);
-			}
-		}
-
-		// Allies - Secret Vehicles
-		p = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(1));
-		for ( int i = 0; p != NULL && i < 10; i++ )
-		{
-			d = Find_Definition(p->Get_Definition(i));
-			if ( d != NULL && d->Get_Class_ID() == (uint32)12304 && ((VehicleGameObjDef*)d)->Get_Type() == VEHICLE_TYPE_FLYING )
-			{
-				p->Set_Hidden(i,true);
-			}
-		}
-	}
 }
 
 
@@ -595,7 +543,7 @@
 
 
 	// Install keyhook
-	if ( Is_Soldier ( obj ) && Get_Player_ID ( obj ) >= 0 )
+	if ( obj->As_SoldierGameObj() && Get_Player_ID ( obj ) >= 0 )
 		InstallHook( Get_Parameter("deployKeyhook"), obj );
 }
 
@@ -604,15 +552,17 @@
 {
 	// Find object
 	GameObject* obj = Commands->Find_Object ( objectID );
-	if ( !obj || Get_Vehicle(obj) || ((SoldierGameObj*)obj)->Is_On_Ladder() )
+	if ( !obj || Get_Vehicle(obj) || obj->As_SoldierGameObj()->Is_On_Ladder() || obj->As_SoldierGameObj()->Is_In_Elevator() )
 		return;
 
 	if ( deployed )
 	{
-		// If deployed for less than 4 seconds dont allow undeploy
-		if ( time(NULL) - lastDeploy < 4 )
+		// If deployed for less than undeployTime seconds dont allow undeploy
+		if ( time(NULL) - lastDeploy < Get_Float_Parameter("undeployTime") )
 		{
-			Send_Message_Player(obj,153,204,25,"You cannot undeploy yet, you must wait at least 4 seconds after deploying to undeploy.");
+			StringClass str;
+			str.Format("You cannot undeploy yet, you must wait at least %f seconds after deploying to undeploy.",Get_Float_Parameter("undeployTime"));
+			Send_Message_Player(obj,153,204,25,str);
 			return;
 		}
 
@@ -630,10 +580,12 @@
 	}
 	else
 	{
-		// If deployed for less than 8 seconds dont allow deploy
-		if ( time(NULL) - lastDeploy < 8 )
+		// If deployed for less than deployTime seconds dont allow deploy
+		if ( time(NULL) - lastDeploy < Get_Float_Parameter("deployTime") )
 		{
-			Send_Message_Player(obj,153,204,25,"You cannot deploy yet, you must wait at least 8 seconds after undeploying to deploy again.");
+			StringClass str;
+			str.Format("You cannot deploy yet, you must wait at least %f seconds after undeploying to deploy again.",Get_Float_Parameter("deployTime"));
+			Send_Message_Player(obj,153,204,25,str);
 			return;
 		}
 
@@ -1045,6 +997,7 @@
 	oreFieldValue = 0;
 	oreLoadLevel = 0;
 	oreValue = 0;
+	animating = false;
 
 	useAI = ( Get_Int_Parameter ( "enableAI" ) == 1 ) ? true : false;
 	aiState = MINER_AISTATE_IDLE;
@@ -1103,6 +1056,10 @@
 		// Unless we are already full increase our load level and the value of our load
 		if ( oreLoadLevel < Get_Int_Parameter("loadLevels") )
 		{
+      // Play the mining sound
+      if (strlen(Get_Parameter("miningSound")) > 0)
+        Commands->Create_Sound(Get_Parameter("miningSound"),Commands->Get_Position(obj),obj);
+
 			oreLoadLevel++;
 			oreValue += oreFieldValue*Get_Int_Parameter("orePerLoadLevel");
 		}
@@ -1111,8 +1068,16 @@
 		if ( oreLoadLevel < Get_Int_Parameter("loadLevels") )
 			Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_INCREASE_ORE_LOAD, oreFieldRand, Get_Float_Parameter("timePerLoadLevel") );
 
-		// Otherwise we are full, if using the AI start driving to the refinery
-		else if ( useAI )
+
+    // Otherwise we are full of ore...
+    else
+    {
+      // Stop the mining animation
+      animating = false;
+      obj->As_PhysicalGameObj()->Clear_Animation();
+
+      // If using the AI start driving to the refinery
+      if ( useAI )
 		{
 			aiState = MINER_AISTATE_RETURN_TO_REFINERY;
 			ReturnToRefinery(obj);
@@ -1122,6 +1087,7 @@
 		else if ( Get_Vehicle_Driver(obj) != NULL )
 			Send_Message_Player ( Get_Vehicle_Driver(obj), 153, 204, 25, "Fully loaded with ore, dock at the Refinery to smelt the ore into credits" );
 	}
+  }
 
 
 	// Message from the ore dump zone notifying us that we have entered it. If
@@ -1206,14 +1172,24 @@
 	// If we are using AI then reset the action now that we have arrived
 	if ( useAI )
 		Commands->Action_Reset ( obj, 101.0f );
+
+  // Start the mining animation if it is not already running
+  if ((strlen(Get_Parameter("miningAnimation")) > 0) && !animating)
+  {
+    animating = true;
+    Commands->Set_Animation(obj,Get_Parameter("miningAnimation"),true,0,0,-1,false);
+  }
 }
 
 
 void dp88_AR_Miner::ExitedOreField ( GameObject *obj, GameObject* oreField )
 {
-	// If this is an AI miner and our state is still collecting ore then we
-	// were probably shoved out of the ore field by some bully in a vehicle
-	// so drive back in to finish mining
+  // Stop the mining animation
+  animating = false;
+  obj->As_PhysicalGameObj()->Clear_Animation();
+
+  // If this is an AI miner and our state is still collecting ore then we were probably shoved out
+  // of the ore field by some bully in a vehicle so drive back in to finish mining
 	if ( useAI && aiState == MINER_AISTATE_COLLECTING_ORE )
 		DriveToOreField(obj);
 }
@@ -1270,6 +1246,12 @@
 
 void dp88_AR_Miner::DockedAtRefinery ( GameObject *obj )
 {
+	// Start dock animation and sound
+	if (strlen(Get_Parameter("dockAnimation")) > 0)
+		Commands->Set_Animation(obj,Get_Parameter("dockAnimation"),false,0,0,-1,false);
+	if (strlen(Get_Parameter("dockSound")) > 0)
+		Commands->Create_Sound(Get_Parameter("dockSound"),Commands->Get_Position(obj),obj);
+
 	// If we are using AI then reset the action now that we have arrived
 	if (useAI)
 		Commands->Action_Reset ( obj, 101.0f );
@@ -1459,7 +1441,7 @@
 			// OK, got the closest... can we chronoshift there?
 
 			// Get physical game object and moveable phys class references (used to check if we can move to the zone)
-			MoveablePhysClass* mphys = ( As_PhysicalGameObj(obj) ) ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+			MoveablePhysClass* mphys = ( obj->As_PhysicalGameObj() ) ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
 
 			// Can we move to this position without getting stuck?
 			if ( !mphys->Can_Teleport( Matrix3D( Commands->Get_Position(zone)) ) )
@@ -1787,9 +1769,9 @@
 
 
 
-/*------------------------
-Remote Control Console Script
---------------------------*/
+// -------------------------------------------------------------------------------------------------
+// Remote Control Console Script
+// -------------------------------------------------------------------------------------------------
 
 void dp88_RemoteControlConsole::Created ( GameObject *obj )
 {
@@ -1801,49 +1783,32 @@
 	m_bEnabled		= true;
 	m_nChargeTime	= Get_Int_Parameter ( "chargeTime" );
 
+  m_pLoopedAnimCtrl = new LoopedAnimationController(obj);
+
 	// Start charge tick timer if necessary and set initial animation frames
 	if ( m_nChargeTime > 0 )
 	{
 		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-		animstate = 0;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameCharging1"), Get_Int_Parameter("animFrameCharging2") );
 	}
 	else
-	{
-		animstate = 1;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
-	}
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameAvailable1"), Get_Int_Parameter("animFrameAvailable2") );
 
 	Commands->Enable_HUD_Pokable_Indicator(obj, (m_nChargeTime == 0));
 }
 
-void dp88_RemoteControlConsole::Animation_Complete ( GameObject *obj, const char *animation_name )
+// -------------------------------------------------------------------------------------------------
+
+void dp88_RemoteControlConsole::Detach ( GameObject* obj )
 {
-	switch(animstate)
+	if (m_pLoopedAnimCtrl)
 	{
-	case 0:
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
-		break;
-	case 1:
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
-		break;
-	case 2:
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
-		break;
-	case 3:
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
-		break;
-	case 4:
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), false, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
-		break;
+		delete m_pLoopedAnimCtrl;
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
+
 void dp88_RemoteControlConsole::Poked ( GameObject *obj, GameObject *poker )
 {
 	//Console_Output ( "[%d:%s:%s] Poked\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
@@ -1933,6 +1898,7 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_RemoteControlConsole::Custom( GameObject *obj, int type, int param, GameObject *sender )
 {
@@ -1963,7 +1929,6 @@
 
 	else if ( type == CUSTOM_REMOTECONTROL_DRIVEREXIT )
 	{
-		//Console_Output ( "[%d:%s:%s] Driver exited, remote control unit now idle\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		DestroyDummy();
 		HandleDriverExit ( obj, Commands->Find_Object(pilotID), sender );
 		pilotID = NULL;
@@ -1975,6 +1940,14 @@
 
 		vehicleID = NULL;
 
+    // Make driver invisible and uncollidable so they can't be killed before they are teleported home
+    if ( GameObject* pilot = Commands->Find_Object(pilotID) )
+    {
+      Commands->Set_Is_Rendered ( pilot, false );
+      Commands->Disable_All_Collisions ( pilot );
+      Update_Network_Object(pilot);
+    }
+
 		// Start timer to return the pilot (if we do it immediately the game will crash...)
 		if ( pilotID != NULL )
 			Commands->Start_Timer ( obj, this, 0.5, TIMER_REMOTECONTROL_DRIVEREXIT );
@@ -1988,14 +1961,10 @@
 			if ( m_nChargeTime > 0 )
 			{
 				Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-				animstate = 0;
-				Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+        m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameCharging1"), Get_Int_Parameter("animFrameCharging2") );
 			}
 			else
-			{
-				animstate = 1;
-				Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
-			}
+        m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameAvailable1"), Get_Int_Parameter("animFrameAvailable2") );
 		}
 
 		Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
@@ -2012,6 +1981,7 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_RemoteControlConsole::Timer_Expired ( GameObject *obj, int number )
 {
@@ -2050,8 +2020,7 @@
 			Create_2D_Sound_Player(pilot, Get_Parameter("connectionEstablishedSound") );
 
 			// Set animation frame
-			animstate = 2;
-			Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
+      m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameActive1"), Get_Int_Parameter("animFrameActive2") );
 		}
 		else	// This should never actually happen... but just in case...
 		{
@@ -2083,14 +2052,15 @@
 				Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
 			else
 			{
-				animstate = 1;
-				Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+        m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameAvailable1"), Get_Int_Parameter("animFrameAvailable2") );
 				Commands->Enable_HUD_Pokable_Indicator(obj, true);
 			}
 		}
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
+
 void dp88_RemoteControlConsole::SetEnabled ( GameObject* obj, bool state )
 {
 	if ( state == m_bEnabled )
@@ -2106,6 +2076,13 @@
 		{
 			Soldier_Transition_Vehicle ( pilot );
 			Create_2D_Sound_Player(pilot, Get_Parameter("consoleOfflineSound") );
+
+      // Make driver invisible and uncollidable so they can't be killed before they are teleported home
+      Commands->Set_Is_Rendered ( pilot, false );
+      Commands->Disable_All_Collisions ( pilot );
+      Update_Network_Object(pilot);
+
+      // Can't do this instantly or the game crashes. Yay!
 			Commands->Start_Timer ( obj, this, 0.5, TIMER_REMOTECONTROL_DRIVEREXIT );
 		}
 	}
@@ -2115,26 +2092,23 @@
 
 	// Update the animation frame state
 	if ( !m_bEnabled )
-	{
-		animstate = 3;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
-	}
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameDisabled1"), Get_Int_Parameter("animFrameDisabled2") );
+
 	else if ( m_nChargeTime > 0 )
 	{
 		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-		animstate = 0;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameCharging1"), Get_Int_Parameter("animFrameCharging2") );
 	}
+
 	else
-	{
-		animstate = 1;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
-	}
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameAvailable1"), Get_Int_Parameter("animFrameAvailable2") );
 }
 
+// -------------------------------------------------------------------------------------------------
+
 void dp88_RemoteControlConsole::CreateDummy ( GameObject* pilot, Vector3 position, float facing )
 {
-	GameObject* dummy = Commands->Create_Object ( "Invisible_Object", position );
+	GameObject* dummy = Commands->Create_Object ( "Invisible_Object_2", position );
 	if ( dummy )
 	{
 		m_pilotDummyID = Commands->Get_ID(dummy);
@@ -2159,6 +2133,8 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
+
 void dp88_RemoteControlConsole::DestroyDummy()
 {
 	if ( m_pilotDummyID != NULL )
@@ -2173,11 +2149,20 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
+
 void dp88_RemoteControlConsole::HandleDriverExit ( GameObject* obj, GameObject* pilot, GameObject* vehicle )
 {
 	if ( pilot )
+  {
 		Commands->Set_Position ( pilot, pilotDummyPos );
 
+    // Make driver visible and collidable again
+    Commands->Set_Is_Rendered ( pilot, true );
+    Commands->Enable_Collisions ( pilot );
+    Update_Network_Object(pilot);
+  }
+
 	// If the vehicle is still alive set it to its idle state
 	if ( vehicle )
 	{
@@ -2193,34 +2178,27 @@
 
 	// Set animation frame
 	if ( !m_bEnabled )
-	{
-		animstate = 3;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
-	}
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameDisabled1"), Get_Int_Parameter("animFrameDisabled2") );
+
 	else if ( vehicle )
-	{
-		animstate = 4;
-		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), false, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
-	}
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameIdle2"), Get_Int_Parameter("animFrameActive2") );
+
 	else if ( m_nChargeTime > 0 )
 	{
 		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-		animstate = 0;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameCharging1"), Get_Int_Parameter("animFrameCharging2") );
 	}
+
 	else
-	{
-		animstate = 1;
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
-	}
+    m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("animationName"), Get_Int_Parameter("animFrameAvailable1"), Get_Int_Parameter("animFrameAvailable2") );
 }
 
 
 
 
-/*------------------------
-Remote Control Vehicle Script
---------------------------*/
+// -------------------------------------------------------------------------------------------------
+// Remote Control Vehicle Script
+// -------------------------------------------------------------------------------------------------
 
 void dp88_RemoteControlVehicle::Created ( GameObject *obj )
 {
@@ -2235,6 +2213,7 @@
 	Send_Custom_Event_To_Objects_With_Script(obj, "dp88_RemoteControlConsole", CUSTOM_REMOTECONTROL_CREATED, Get_Int_Parameter("remoteControlID"), 0 );
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_RemoteControlVehicle::Custom( GameObject *obj, int type, int param, GameObject *sender )
 {
@@ -2268,6 +2247,7 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_RemoteControlVehicle::Killed ( GameObject* obj, GameObject* killer )
 {
@@ -2767,7 +2747,12 @@
 {
 	// Notify adjacent towers to stop assisting us if they were
 	for ( int i = 0; i < adjacentTowerCount; i++ )
+	{
+		if (Commands->Find_Object(adjacentTowers[i]) != obj)
+		{
 		Commands->Send_Custom_Event(obj,Commands->Find_Object(adjacentTowers[i]), CUSTOM_PRISMTOWER_STOP_CHARGING,0,0.0f);
+		}
+	}
 
 	// Deregister this tower
 	deregisterTower(Commands->Get_ID(obj));
@@ -2965,7 +2950,7 @@
 	// we are charging, if any
 	for ( int i = 0; i < adjacentTowerCount; ++i )
 	{
-		if ( adjacentTowers[i] != targetID )
+		if ( adjacentTowers[i] != targetID && Commands->Find_Object(adjacentTowers[i]) != obj)
 			Commands->Send_Custom_Event(obj, Commands->Find_Object(adjacentTowers[i]), CUSTOM_PRISMTOWER_REQUEST_CHARGING, (int)targetPriority, 0.0f );
 	}
 }
@@ -2977,8 +2962,13 @@
 {
 	// Send out end assistance notifications to all adjacent towers
 	for ( int i = 0; i < adjacentTowerCount; ++i )
+	{
+		if (Commands->Find_Object(adjacentTowers[i]) != obj)
+		{
 		Commands->Send_Custom_Event(obj, Commands->Find_Object(adjacentTowers[i]), CUSTOM_PRISMTOWER_STOP_CHARGING, 0, 0.0f );
 }
+	}
+}
 
 
 
@@ -3028,7 +3018,18 @@
 	// Destroy parent object if its still alive
 	GameObject* parent = Commands->Find_Object ( parentObjID );
 	if ( parent )
-		Commands->Apply_Damage ( parent, 5000.00, "Death", NULL );
+	{
+    // If the parent is a soldier in a vehicle we can't simply kill them because things go horribly wrong. Instead
+    // eject them from a vehicle and attach JFW_Timer_Destroy_Object to kill them as soon as possible.
+    if ( parent->As_SoldierGameObj() && parent->As_SoldierGameObj()->Is_In_Vehicle() )
+    {
+      Soldier_Transition_Vehicle ( parent );
+      Commands->Attach_Script ( parent, "JFW_Timer_Destroy_Object", "1.0,547859,5000.0,Death" );
+      Destroy_Script();   // Prevent equaliseHealth() getting called and trying to kill the driver
+    }
+		else
+		    Commands->Apply_Damage ( parent, 5000.00, "None", NULL );
+	}
 }
 
 void dp88_linkHealth::equaliseHealth ( GameObject* obj )
@@ -3043,8 +3044,15 @@
 	/* Work out difference in our health and armour since last check */
 	float difference = ((Commands->Get_Health(obj)-lastHealth)+(Commands->Get_Shield_Strength(obj)-lastArmour));
 
-	/* Apply damage to parent using 'None' warhead (this should be 1-1
-	ratio against all skin and shield types */
+	/* Apply damage to parent using 'None' warhead (this should be 1-1 ratio against all skin and
+  shield types. Special case scenario: if the target is a soldier in a vehicle we need to use a
+  special function to override the check that prevents damage to soldiers in a vehicle */
+  if ( parent->As_SoldierGameObj() && parent->As_SoldierGameObj()->Is_In_Vehicle() )
+  {
+    OffenseObjectClass offense(difference*-1.0f, ArmorWarheadManager::Get_Warhead_Type("None"), NULL);
+    parent->As_SoldierGameObj()->Apply_Damage_IgnoreVehicleCheck ( offense, 1, -1 );
+  }
+  else
 	Commands->Apply_Damage ( parent, difference*-1.0f, "None", NULL );
 
 	/* Update our health/armour from the parents new health/armour */
@@ -3100,9 +3108,9 @@
 // CLEG resistance script
 ScriptRegistrant<dp88_AR_CLEG_target> dp88_AR_CLEG_target_Registrant( "dp88_AR_CLEG_target", "resistance=20:int,clegEffectPreset=null:string" );
 
-// Ore Harvesting
-ScriptRegistrant<dp88_AR_Miner> dp88_AR_Miner_Registrant("dp88_AR_War_Miner","enableAI=1:int,loadLevels=10:int,orePerLoadLevel=100:int,timePerLoadLevel=2.0:float,unloadTime=8.0:float,aiStartDelay=10:int");
-ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant("dp88_AR_Chrono_Miner","enableAI=1:int,chronoshift_time=2.5:float,chronoshift_out_effect_preset:string,chronoshift_out_effect_time:float,chronoshift_in_effect_preset:string,chronoshift_in_effect_time:float,chronoshiftKeyhook=VDeploy:string,loadLevels=10:int,orePerLoadLevel=50:int,timePerLoadLevel=1.00:float,unloadTime=4.0:float,emergencyChronoshiftHealthThreshold=30.0:float,aiStartDelay=10:int");
+// Ore Miners
+ScriptRegistrant<dp88_AR_Miner> dp88_AR_Miner_Registrant("dp88_AR_War_Miner","enableAI=1:int,loadLevels=10:int,orePerLoadLevel=100:int,timePerLoadLevel=2.0:float,unloadTime=8.0:float,aiStartDelay=10:int,dockAnimation:string,dockSound:string,miningAnimation:String,miningSound:string");
+ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant("dp88_AR_Chrono_Miner","enableAI=1:int,chronoshift_time=2.5:float,chronoshift_out_effect_preset:string,chronoshift_out_effect_time:float,chronoshift_in_effect_preset:string,chronoshift_in_effect_time:float,chronoshiftKeyhook=VDeploy:string,loadLevels=10:int,orePerLoadLevel=50:int,timePerLoadLevel=1.00:float,unloadTime=4.0:float,emergencyChronoshiftHealthThreshold=30.0:float,aiStartDelay=10:int,dockAnimation:string,dockSound:string,miningAnimation:String,miningSound:string");
 ScriptRegistrant<dp88_AR_Chrono_Miner_Chronozone> dp88_AR_Chrono_Miner_Chronozone_Registrant("dp88_AR_Chrono_Miner_Chronozone","");
 ScriptRegistrant<dp88_AR_Ore_Field_Zone> dp88_AR_Ore_Field_Zone_Registrant("dp88_AR_Ore_Field_Zone","oreValue=1:int");
 ScriptRegistrant<dp88_AR_Ore_Deposit_Zone> dp88_AR_Ore_Deposit_Zone_Registrant("dp88_AR_Ore_Deposit_Zone","teamID=0:int");
